Wt: Wt::WSuggestionPopup Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Wt::WSuggestionPopup Class Reference
Model/view system

A widget which popups to assist in editing a textarea or lineedit. More...

`#include <Wt/WSuggestionPopup.h>`

Inheritance diagram for Wt::WSuggestionPopup:
[legend]

## Classes
struct | Options
| A configuration object to generate a matcher and replacer JavaScript function. More...

## Public Types
typedef PopupTrigger | Trigger
| Typedef for enum Wt::PopupTrigger.
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.

## Public Member Functions
| WSuggestionPopup (const Options &options)
| Creates a suggestion popup.
| WSuggestionPopup (const std::string &matcherJS, const std::string &replacerJS)
| Creates a suggestion popup with given matcherJS and replacerJS.
void | forEdit (WFormWidget *edit, WFlags< PopupTrigger > popupTriggers=PopupTrigger::Editing)
| Lets this suggestion popup assist in editing an edit field.
void | removeEdit (WFormWidget *edit)
| Removes the edit field from the list of assisted editors.
void | showAt (WFormWidget *edit)
| Shows the suggestion popup at an edit field.
void | clearSuggestions ()
| Clears the list of suggestions.
void | addSuggestion (const WString &suggestionText, const WString &suggestionValue=WString::Empty)
| Adds a new suggestion.
void | setModel (const std::shared_ptr< WAbstractItemModel > &model)
| Sets the model to be used for the suggestions.
std::shared_ptr< WAbstractItemModel > | model () const
| Returns the data model.
void | setModelColumn (int index)
| Sets the column in the model to be used for the items.
void | setDefaultIndex (int row)
| Sets a default selected value.
int | defaultIndex () const
| Returns the default value.
void | setFilterLength (int count)
| Sets the minimum input length before showing the popup.
int | filterLength () const
| Returns the filter length.
Signal< WString > & | filterModel ()
| Signal that indicates that the model should be filtered.
Signal< int, WFormWidget * > & | activated ()
| Signal emitted when a suggestion was selected.
void | setDropDownIconUnfiltered (bool isUnfiltered)
| When drop down icon is clicked the popup content will be unfiltered.
void | setAutoSelectEnabled (bool enabled)
| When the popup is opened the first item is automatically selected.
int | currentItem () const
| Returns the last activated index.
void | setEditRole (ItemDataRole role)
| Sets the role used for editing the line edit with a chosen item.
ItemDataRole | editRole () const
Public Member Functions inherited from Wt::WPopupWidget
| WPopupWidget (std::unique_ptr< WWidget > impl)
| Constructor.
virtual | ~WPopupWidget ()
| Destructor.
void | setAnchorWidget (WWidget *widget, Orientation orientation=Orientation::Vertical)
| Sets an anchor widget.
Orientation | orientation () const
| Returns the orientation.
void | setTransient (bool transient, int autoHideDelay=0)
| Sets transient property.
bool | isTransient () const
| Returns whether the popup is transient.
int | autoHideDelay () const
| Returns the auto-hide delay.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
Signal & | hidden ()
| Signal emitted when the popup is hidden.
Signal & | shown ()
| Signal emitted when the popup is shown.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual void | load () override
| Loads content just before the widget is used.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Static Public Member Functions
static std::string | generateMatcherJS (const Options &options)
| Creates a standard matcher JavaScript function.
static std::string | generateReplacerJS (const Options &options)
| Creates a standard replacer JavaScript function.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WPopupWidget
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Detailed Description

A widget which popups to assist in editing a textarea or lineedit.

This widget may be associated with one or more WFormWidgets (typically a WLineEdit or a WTextArea).

The popup provides the user with suggestions to enter input. The popup can be used by one or more editors, using forEdit(). The popup will show when the user starts editing the edit field, or when the user opens the suggestions explicitly using a drop down icon or with the down key. The popup positions itself intelligently just below or just on top of the edit field. It offers a list of suggestions that match in some way with the current edit field, and dynamically adjusts this list. The implementation for matching individual suggestions with the current text is provided through a JavaScript function. This function may also highlight part(s) of the suggestions to provide feed-back on how they match.

WSuggestionPopup is an MVC view class, using a simple WStringListModel by default. You can set a custom model using setModel(). The model can provide different text for the suggestion text (Wt::ItemDataRole::Display) and value (editRole()). The member methods clearSuggestions() and addSuggestion() manipulate this model.

By default, the popup implements all filtering client-side. To support large datasets, you may enable server-side filtering of suggestions based on the input. The server-side filtering may provide a coarse filtering using a fixed size prefix of the entered text, and complement the client-side filtering. To enable server-side filtering, use setFilterLength() and listen to filter notification using the modelFilter() signal. Whenever a filter event is generated you can adjust the model's content according to the filter (e.g. using a WSortFilterProxyModel). By using setMaximumSize() you can also limit the maximum height of the popup, in which case scrolling is supported (similar to a combo-box).

The class is initialized with an Options struct which configures how suggestion filtering and result editing is done. Alternatively, you can provide two JavaScript functions, one for filtering the suggestions, and one for editing the value of the textarea when a suggestion is selected.

The matcherJS function must have the following JavaScript signature:

function (editElement) {
// fetch the location of cursor and current text in the editElement.
// return a function that matches a given suggestion with the current value of the editElement.
return function(suggestion) {
// 1) if suggestion is null, simply return the current text 'value'
// 2) check suggestion if it matches
// 3) add highlighting markup to suggestion if necessary
return { match : ..., // does the suggestion match ? (boolean)
suggestion : ... // modified suggestion with highlighting
};
}
}

The replacerJS function that edits the value has the following JavaScript signature.

function (editElement, suggestionText, suggestionValue) {
// editElement is the form element which must be edited.
// suggestionText is the displayed text for the matched suggestion.
// suggestionValue is the stored value for the matched suggestion.
// computed modifiedEditValue and modifiedPos ...
editElement.value = modifiedEditValue;
editElement.selectionStart = edit.selectionEnd = modifiedPos;
}

To style the suggestions, you should style the <span> element inside this widget, and the <span>."sel" element to style the current selection.

Usage example:

// options for email address suggestions
Wt::WSuggestionPopup::Options contactOptions
= { "<b>", // highlightBeginTag
"</b>", // highlightEndTag
',', // listSeparator (for multiple addresses)
" \n", // whitespace
"-., \"@\n;", // wordSeparators (within an address)
", " // appendReplacedText (prepare next email address)
};
Wt::WSuggestionPopup *popup = addNew<Wt::WSuggestionPopup>(contactOptions);
Wt::WTextArea *textEdit = addNew<Wt::WTextArea>();
popup->forEdit(textEdit);
// load popup data
for (unsigned i = 0; i < contacts.size(); ++i)
popup->addSuggestion(contacts[i].formatted(), contacts[i].formatted());
Wt::WSuggestionPopup
A widget which popups to assist in editing a textarea or lineedit.
Definition WSuggestionPopup.h:191
Wt::WSuggestionPopup::forEdit
void forEdit(WFormWidget *edit, WFlags< PopupTrigger > popupTriggers=PopupTrigger::Editing)
Lets this suggestion popup assist in editing an edit field.
Wt::WSuggestionPopup::addSuggestion
void addSuggestion(const WString &suggestionText, const WString &suggestionValue=WString::Empty)
Adds a new suggestion.
Wt::WTextArea
A widget that provides a multi-line edit.
Definition WTextArea.h:47
Wt::WSuggestionPopup::Options
A configuration object to generate a matcher and replacer JavaScript function.
Definition WSuggestionPopup.h:201

Note
  This widget is not supposed to be added explicitly, as it is a global widget (much like WPopupWidget). Managing its lifetime can be achieved with WContainerWidget::addNew() or WObject::addChild(), where the former uses the latter. Do NOT bind it to a template using WTemplate::bindWidget(), WTemplate::bindNew() or WLayout::addWidget(). If bound this way, the placeholder is not replaced with the correct list of suggestions, since this causes the widget to be placed into the widget tree twice.

A screenshot of this example:

An example WSuggestionPopup (default) | An example WSuggestionPopup (polished)

When using the DropDownIcon trigger, an additional style class is provided for the edit field: `Wt-suggest-dropdown`, which renders the icon to the right inside the edit field. This class may be used to customize how the drop down icon is rendered.

Note
  This widget requires JavaScript support.

## Constructor & Destructor Documentation

## ◆ WSuggestionPopup() [1/2]

Wt::WSuggestionPopup::WSuggestionPopup | ( | const Options & | options | ) |

Creates a suggestion popup.

The popup using a standard matcher and replacer implementation that is configured using the provided `options`.

See also
  generateMatcherJS(), generateReplacerJS()

## ◆ WSuggestionPopup() [2/2]

Wt::WSuggestionPopup::WSuggestionPopup | ( | const std::string & | matcherJS,
|  | const std::string & | replacerJS )

Creates a suggestion popup with given matcherJS and replacerJS.

See supra for the expected signature of the matcher and replace JavaScript functions.

## Member Function Documentation

## ◆ activated()

Signal< int, WFormWidget * > & Wt::WSuggestionPopup::activated | ( |  | ) |

Signal emitted when a suggestion was selected.

The selected item is passed as the first argument and the editor as the second.

## ◆ addSuggestion()

void Wt::WSuggestionPopup::addSuggestion | ( | const WString & | suggestionText,
|  | const WString & | suggestionValue = WString::Empty )

Adds a new suggestion.

This adds an entry to the underlying model. The `suggestionText` is set as Wt::ItemDataRole::Display and the `suggestionValue` (which is inserted into the edit field on selection) is set as editRole().

See also
  clearSuggestions(), setModel()

## ◆ clearSuggestions()

void Wt::WSuggestionPopup::clearSuggestions | ( |  | ) |

Clears the list of suggestions.

This clears the underlying model.

See also
  addSuggestion()

## ◆ currentItem()

int Wt::WSuggestionPopup::currentItem | ( |  | ) | const

Returns the last activated index.

Returns -1 if the popup hasn't been activated yet.

See also
  activated()

## ◆ defaultIndex()

int Wt::WSuggestionPopup::defaultIndex | ( |  | ) | const

Returns the default value.

See also
  setDefaultValue()

## ◆ editRole()

ItemDataRole Wt::WSuggestionPopup::editRole | ( |  | ) | const

Returns the role used for editing the line edit.

setEditRole()

## ◆ filterLength()

int Wt::WSuggestionPopup::filterLength | ( |  | ) | const

Returns the filter length.

See also
  setFilterLength()

## ◆ filterModel()

Signal< WString > & Wt::WSuggestionPopup::filterModel | ( |  | ) |

Signal that indicates that the model should be filtered.

The argument is the initial input. When Editing is used as edit trigger, its length will always equal the filterLength(). When DropDownIcon is used as edit trigger, the input length may be less than filterLength(), and the the signal will be called repeatedly as the user provides more input.

For example, if you are using a WSortFilterProxyModel, you could react to this signal with:

void MyClass::filterSuggestions(const WString& filter)
{
proxyModel->setFilterRegExp(filter + ".*");
}
Wt::WString
A value class which describes a locale-aware unicode string.
Definition WString.h:74

## ◆ forEdit()

void Wt::WSuggestionPopup::forEdit | ( | WFormWidget * | edit,
|  | WFlags< PopupTrigger > | popupTriggers = PopupTrigger::Editing )

Lets this suggestion popup assist in editing an edit field.

A single suggestion popup may assist in several edits by repeated calls of this method.

The `popupTriggers` control how editing is triggered (either by the user editing the field by entering keys or by an explicit drop down menu that is shown inside the edit).

See also
  removeEdit()

## ◆ generateMatcherJS()

static std::string Wt::WSuggestionPopup::generateMatcherJS | ( | const Options & | options | ) |
| static

Creates a standard matcher JavaScript function.

This returns a JavaScript function that provides a standard implementation for the matching input, based on the given `options`.

## ◆ generateReplacerJS()

static std::string Wt::WSuggestionPopup::generateReplacerJS | ( | const Options & | options | ) |
| static

Creates a standard replacer JavaScript function.

This returns a JavaScript function that provides a standard implementation for reacting to a match activation, editing the line edit text.

## ◆ model()

std::shared_ptr< WAbstractItemModel > Wt::WSuggestionPopup::model | ( |  | ) | const

Returns the data model.

See also
  setModel()

## ◆ removeEdit()

void Wt::WSuggestionPopup::removeEdit | ( | WFormWidget * | edit | ) |

Removes the edit field from the list of assisted editors.

The editor will no longer be assisted by this popup widget.

See also
  forEdit().

## ◆ render()

virtual void Wt::WSuggestionPopup::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WPopupWidget.

## ◆ setAutoSelectEnabled()

void Wt::WSuggestionPopup::setAutoSelectEnabled | ( | bool | enabled | ) |

When the popup is opened the first item is automatically selected.

This cannot be changed after the widget is rendered. The default value is true.

## ◆ setDefaultIndex()

void Wt::WSuggestionPopup::setDefaultIndex | ( | int | row | ) |

Sets a default selected value.

`row` is the model row that is selected by default (only if it matches the current input).

The default value is -1, indicating no default.

## ◆ setDropDownIconUnfiltered()

void Wt::WSuggestionPopup::setDropDownIconUnfiltered | ( | bool | isUnfiltered | ) |

When drop down icon is clicked the popup content will be unfiltered.

See also
  forEdit() and enum PopupTrigger

## ◆ setEditRole()

void Wt::WSuggestionPopup::setEditRole | ( | ItemDataRole | role | ) |

Sets the role used for editing the line edit with a chosen item.

The default value is ItemDataRole::User.

## ◆ setFilterLength()

void Wt::WSuggestionPopup::setFilterLength | ( | int | count | ) |

Sets the minimum input length before showing the popup.

When the user has typed this much characters, filterModel() is emitted which allows you to filter the model based on the initial input. The filtering is done as long as the model indicates that results are partial by setting a ItemDataRole::StyleClass of "Wt-more-data" on the last item.

The default value is 0.

A value of -1 is a equivalent to 0 but filtering is always applied as if the last item always has "Wt-more-data" (for backwards compatibility)

See also
  filterModel()

## ◆ setModel()

void Wt::WSuggestionPopup::setModel | ( | const std::shared_ptr< WAbstractItemModel > & | model | ) |

Sets the model to be used for the suggestions.

The `model` may not be `0`.

The default value is a WStringListModel that is owned by the suggestion popup.

The Wt::ItemDataRole::Display is used for the suggestion text. The editRole() is used for the suggestion value, unless empty, in which case the suggestion text is used as value.

See also
  setModelColumn(int)

## ◆ setModelColumn()

void Wt::WSuggestionPopup::setModelColumn | ( | int | index | ) |

Sets the column in the model to be used for the items.

The column `index` in the model will be used to retrieve data.

The default value is 0.

See also
  setModel()

## ◆ showAt()

void Wt::WSuggestionPopup::showAt | ( | WFormWidget * | edit | ) |

Shows the suggestion popup at an edit field.

This is equivalent to the user triggering the suggestion popup to be shown.